function util_get_store_url(urlString = ''){
    //var urlString = "https://www.example.com/path/to/page?query=123#section";
    if(urlString.indexOf('.html') != -1){
        let _urlStringArr = urlString.split('.html');
        urlString = _urlStringArr[0];
    }
    console.log(urlString);
    // 定义一个正则表达式模式来匹配URL
    var urlPattern = /^(https?):\/\/([^/]+)(\/[^?#]*)?(\?[^#]*)?(#.*)?$/;
    // 使用正则表达式匹配URL
    var matches = urlString.match(urlPattern);
    console.log(matches);
    if (matches) {
      var protocol = matches[1] || "https://"; // 默认协议是https
      var hostname = matches[2];
      var path = matches[3];
      if(path){
          let _tmp_path_arr = path.split('/');
          return protocol+'://'+hostname+'/'+_tmp_path_arr[1]+'/info.html';
      }
    } else {
      return '';
    }
}

async function fetch_request(url){
     console.log('fetch url');
     console.log(url);
     var shangjia_infos = [];
     let options = {
         method: 'get',
         headers: {
             'Content-Type':'application/json;charset=utf-8'
         },
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options).then(res =>
        res.json()).then(d => {
            console.log('fetch response:');
            console.log(d);
            if(d){
                let companyWithOfferLists = d['data']['data']['companyWithOfferLists'];
                for (let _f=0;_f<companyWithOfferLists.length;_f++){
                    let _factoryInfo = companyWithOfferLists[_f]['factoryInfo'];
                    shangjia_infos.push({
                        '_shangjia_name': _factoryInfo['company'],
                        '_shangjia_company_type':_factoryInfo['isFactory']=='Y'?'工厂':'非工厂',
                        '_shangjia_business': _factoryInfo['recommendWords'].join(','),
                        '_shangjia_product': _factoryInfo['productionService'],
                        '_shangjia_city':_factoryInfo['city'],
                        '_shangjia_a_link': _factoryInfo['factoryDetailUrl'],
                    });
                }
            }
            //
        })
    return shangjia_infos;
}

//搜索页采集
function shangjia_search_caiji(){
    console.log('shangjia_search_caiji');
    let current_url = window.location.href;
    if(current_url) {
        //search/mall
        if (current_url.indexOf('search') != -1) {
            var shangjia_infos = [];
            console.log('shangjia_search_caiji a2');
            $("#searchResults .SearchResult_SearchResult__fashionGridItem__vdTba").each(function (){
                console.log('shangjia_search_caiji a3');
                let _shangjia_name = '';
                let _shangjia_contact_info_url = '';
                let _shangjia_business = '';
                let _shangjia_product = '';
                let _shangjia_company_type = '';
                let _shangjia_city = '';
                //
                let _shangjia_a_link = $(this).find('a.SearchResult_SearchResult__detailsContainerLink__0hDP4').attr('href');
                if(_shangjia_a_link){
                    _shangjia_a_link = util_get_store_url(_shangjia_a_link);
                    let _shangjia_id = _shangjia_a_link;
                    //

                    let _shangjia_info = {
                        '_shangjia_id': _shangjia_id,
                        '_shangjia_a_link':_shangjia_a_link,
                        '_shangjia_name': _shangjia_name
                    };
                    //console.log(_shangjia_info);
                    shangjia_infos.push(_shangjia_info);
                    //
                }
                //
                if(shangjia_infos.length >=50){
                    var message = {
                        action: 'shangjia_items_update',
                        info: '',
                        shangjia_infos: shangjia_infos
                    };
                    send_message_to_popup(message);
                    shangjia_infos = [];
                }
                //
            });
            //
            var message = {
                action: 'shangjia_items_update',
                info: '',
                shangjia_infos: shangjia_infos
            };
            send_message_to_popup(message);
        }
    }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'fetch'){
            //找供应商
            if(performanceResourceItem['name'].indexOf('searchbff/pc/search/autoPager')!=-1) {
                //console.log(performanceResourceItem['name']);
                console.log('bbbb' + performanceResourceItem['name']);
                //
                setTimeout(function () {
                    shangjia_search_caiji();
                }, 1000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
//observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function () {
    let current_url = window.location.href;
    if(current_url) {
        if (current_url.indexOf('search') != -1) {
            setTimeout(function() {
                    shangjia_search_caiji();
                }, 1000);
        }else if(current_url.indexOf('category') != -1){
            setTimeout(function() {
                    shangjia_search_caiji();
                }, 1000);
        }
    }
});

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}
//
function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}
//
function get_product_lunbo_imgs(){
    console.log('aaaa');
    //图片列表
    $('._2AOclWz7 ._3ACovDZO').each(function (){
        var _img = $(this).find('img').attr('src');
        if(_img.indexOf("?") !== -1){
            var _imgarr = _img.split('?')
            _img = _imgarr[0];
            //
            _img_src = _img;
            var _imgarr = _img.split('/')
            _img_name = _imgarr[_imgarr.length-1]
            _img_name_arr = _img_name.split('.')
            _img_name = _img_name_arr[0]
            //
            downloadIamge(_img_src,_img_name);
        }

    })
    //
}
//
function get_product_details_imgs(){
    console.log('aaaa');
    //
    $('._151rnt-L').find('img').each(function (){
        var _detail_img = $(this).attr('src');
        if(_detail_img.indexOf("?") !== -1){
            var _detail_imgarr = _detail_img.split('?')
            _detail_img = _detail_imgarr[0];
            //
            _img_src = _detail_img;
            var _imgarr = _detail_img.split('/')
            _img_name = _imgarr[_imgarr.length-1]
            _img_name_arr = _img_name.split('.')
            _img_name = _img_name_arr[0]
            //
            downloadIamge(_img_src,_img_name);
        }

    })

}
//
// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract-product-lunbo-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_lunbo_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-product-details-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_details_imgs();
        sendResponse(catalog_products_url);
    }
})
//